import React, { useMemo } from 'react';
import styled from 'styled-components';
import { path } from 'ramda';
import { Box } from '../../elements';
import defaultTheme from '../../../theme';
import { useDashboardData } from '../context';
import { Loader } from '../../modules';
var StatisticBox = styled(Box).attrs({
    centered: true,
    verticalAlign: 'center',
})(function (_a) {
    var theme = _a.theme, color = _a.color;
    return ({
        height: '100%',
        borderRadius: theme.sizes.borderRadius,
        flexWrap: 'nowrap',
        '& > small': {
            fontSize: '0.6em',
        },
    });
});
StatisticBox.defaultProps = {
    theme: defaultTheme,
};
export var Statistic = function (_a) {
    var config = _a.config;
    var data = useDashboardData(config);
    var value = useMemo(function () {
        var prop = path(['data', 'prop'], config);
        return prop ? path([prop], data.result) : data.result;
    }, [data, config]);
    if (!data || data.loading) {
        return React.createElement(Loader, { active: true });
    }
    if (!value) {
        return (React.createElement(Box, { centered: true, verticalAlign: "center" },
            React.createElement("small", null, "No Data Found")));
    }
    return (React.createElement(StatisticBox, null,
        React.createElement("h1", null, value)));
};
export default Statistic;
